# Chapter Three: Understanding Your Bitcoin Setup

This chapter lays out the basics for understanding your bitcoin setup and how to use its wallet features.

It presumes that you have a VPS with bitcoin installed, running bitcoind. It also presumes that you are connected to testnet, allowing for access to bitcoins without using real funds. You can either do this by hand, per [2.1: Setting up a Bitcoin-Core VPS by Hand](./2_1_Setting_Up_a_Bitcoin-Core_VPS_by_Hand.md), or do it with a Linode StackScript at Linode.com, per [2.2: Setting up a Bitcoin-Core VPS with StackScript](./2_2_Setting_Up_a_Bitcoin-Core_VPS_with_StackScript.md).

## Objectives for This Chapter

After working through this chapter, a developer will be able to:

   * Demonstrate that Their Bitcoin Node is Installed and Up-to-date
   * Create an Address to Receive Bitcoin Funds
   * Use Basic Wallet Commands
   
Supporting objectives include the ability to:

   * Understand the Basic Bitcoin File Layout
   * Use Basic Informational Commands
   * Understand What a Bitcoin Address Is
   * Understand What a Wallet Is
   
## Table of Contents

* [Section One: Verifying Your Bitcoin Setup](3_1_Verifying_Your_Bitcoin_Setup.md)
* [Section Two: Knowing Your Bitcoin Setup](3_2_Knowing_Your_Bitcoin_Setup.md)
* [Section Three: Setting Up Your Wallet](3_3_Setting_Up_Your_Wallet.md)
   * [Interlude: Using Command-Line Variables](3_3__Interlude_Using_Command-Line_Variables.md)
* [Section Four: Receiving a Transaction](3_4_Receiving_a_Transaction.md)

