# Chapter Six: Expanding Bitcoin Transactions

Basic bitcoin transactions: (1) send funds; (2) to a single P2PKH recipient; (3) immediately. However, all three parts of this definition can be expanded using more complex Bitcoin transactions, which can alternatively send data, which can send to a group of recipients, or which can send at a later time. These three options represent further empowerment of Bitcoin and also the furthest boundaries of what you can do with the basic `bitcoin-cli` command.

## Objectives for This Section

After working through this chapter, a developer will be able to:

   * Create Multisignature Bitcoin Addresses
   * Create Transactions with Locktimes
   * Create Transactions with Data
   
Supporting objectives include the ability to:

   * Understand How to Spend Funds Sent to a Multisignature
   * Plan for the Power of Multisignatures
   * Understand the Different Sorts of Timelocks
   * Plan for the Power of Locktime
   * Plan for the Power of OP_RETURN
   
## Table of Contents

   * [Section One: Sending a Transaction with a Multsig](6_1_Sending_a_Transaction_to_a_Multisig.md)
   * [Section Two: Spending a Transaction with a Multsig](6_2_Spending_a_Transaction_to_a_Multisig.md)
   * [Section Three: Sending & Spending an Automated Multisig](6_3_Sending_an_Automated_Multisig.md)
   * [Section Four: Sending a Transaction with a Locktime](6_4_Sending_a_Transaction_with_a_Locktime.md)
   * [Section Five: Sending a Transaction with Data](6_5_Sending_a_Transaction_with_Data.md)
