# Chapter 8: Embedding Bitcoin Scripts in P2SH Transactions

Bitcoin Script moves down several levels of abstraction, allowing you to minutely control the redemption conditions of Bitcoin funds. But, how do you actually incorporate those Bitcoin Scripts into the transactions you've been building to date? The answer is a new sort of Bitcoin transaction, the P2SH.

## Objectives for This Chapter

After working through this chapter, a developer will be able to:

   * Design a Bitcoin Script
   * Design a P2SH Transaction
   
Supporting objectives include the ability to:

   * Understand the P2SH Script
   * Understand the Multisig Script
   * Test a Bitcoin Script
   * Understand How to Spend Funds Sent to a P2SH
   
## Table of Contents

* [Section One: Understanding the Foundation of P2SH](8_1_Understanding_the_Foundation_of_P2SH.md)
* [Section Two: Building a Bitcoin Script with P2SH](8_2_Building_a_Bitcoin_Script_with_P2SH.md)
* [Section Three: Scripting a Multisig](8_3_Scripting_a_Multisig.md)
* [Section Four: Testing a Bitcoin Script](8_4_Testing_a_Bitcoin_Script.md)
* [Section Five: Spending a Transaction with a Bitcoin script](8_5_Spending_a_Transaction_with_a_Bitcoin_script.md) — Awaiting API Work

